#ifndef LITEFS_H
#define LITEFS_H

#include <sys/stat.h>
#include <limits.h>

#define LITEFS_PROTOCOL_VERSION	2

enum LITE_CMD{
	LITE_OPEN,
	LITE_CLOSE,
	LITE_READ,
	LITE_WRITE,
	LITE_SEEK,
	LITE_STAT,
	LITE_LSTAT,
	LITE_FSTAT,
	LITE_OPENDIR,
	LITE_READDIR,
	LITE_CLOSEDIR,
	LITE_UNLINK,
	LITE_RENAME,
	LITE_MKDIR,
	LITE_RMDIR,
	LITE_MKNOD,
	LITE_LINK,
	LITE_SYMLINK,
	LITE_CHMOD,
	LITE_CHOWN,
	LITE_LCHOWN,
	LITE_CHDIR,
	LITE_UTIMES,
	LITE_ACCESS,
	LITE_READLINK,
	LITE_VERSION,
	LITE_SHUTDOWN,		// End litefs back-end
	LITE_FCHMOD,
	LITE_FCHOWN,
};

struct LITE_REQUEST {
	LITE_CMD cmd;
	int handle;
	int mode;
	int perm;
	int len;		// Len of data
};

struct LITE_REQUEST_DATA: LITE_REQUEST {
	char buf[32000];
};

enum LITE_STATUS {
	LITE_STATUS_FAIL,		// The request failed
	LITE_STATUS_OK,			// The request succeed, no special value
							// returned
	LITE_STATUS_HANDLE,		// A file handle was transmited
	LITE_STATUS_STAT,		// struc stat was sent
	LITE_STATUS_SEEK,		// data contains lseek return value
};

struct LITE_REPLY {
	LITE_STATUS status;
	int data;
	int errcode;
	int len;
};

struct LITE_REPLY_DATA: LITE_REPLY {
	char buf[32000];
};

#endif


